/*
 *  Copyright (c) 2004 on behalf of the EU EGEE Project:
 *  The European Organization for Nuclear Research (CERN),
 *  Istituto Nazionale di Fisica Nucleare (INFN), Italy
 *  Datamat Spa, Italy
 *  Centre National de la Recherche Scientifique (CNRS), France
 *  CS Systeme d'Information (CSSI), France
 *  Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
 *  Universiteit van Amsterdam (UvA), Netherlands
 *  University of Helsinki (UH.HIP), Finland
 *  University of Bergen (UiB), Norway
 *  Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom
 */
#ifndef RGMA_TCPSOCKET_H
#define RGMA_TCPSOCKET_H
#include "rgma/RGMAException.h"
#include "rgma/RemoteException.h"
#include "rgma/Socket.h"
#include <arpa/inet.h>
//#include <ctype.h>
//#include <errno.h>
//#include <netdb.h>
//#include <sys/socket.h>
//#include <unistd.h>
#include <string>

namespace glite
{
    namespace rgma
    {
        /**
         * TCP socket wrapper
         * 
         */
        class TCPSocket:public Socket
        {
            private:

                struct sockaddr_in m_addr;

            protected:
                int m_sock;
            public:
                virtual ~TCPSocket();
                TCPSocket();
                virtual void connect(std::string host, int port) throw(RGMAException, RemoteException);
                virtual void write(std::string request, std::string& resonse) throw(RGMAException, RemoteException);
                virtual void close()throw(RGMAException, RemoteException);
        };
    }
}
#endif
